## Copyright (C) 2000 uschoe
##
## This file is part of Octave.
##
## Octave is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2, or (at your option)
## any later version.
##
## Octave is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with Octave; see the file COPYING.  If not, write to the Free
## Software Foundation, 59 Temple Place - Suite 330, Boston, MA
## 02111-1307, USA.

## usage: coordtomat (M,n)
##
## returns a 2d matrix where the point coordinates in the Nx2 matrix M
## are turned on.
##

## Author: Yoonsuck Choe <yschoe@cs.utexas.edu>

function m = coordtomat (M,n)

	m = zeros(n+1,n+1);
	
  	mrows = rows(M);

	scale = max(vec(M))-min(vec(M));
	
	Mlocal = (((M.-min(vec(M)))./scale)*n);

	for i = 2:mrows
		v = Mlocal(i,:);
		m(v(1)+1,v(2)+1) = 1;
	endfor
		
endfunction
