# cosmat(N,freq,theta) : return [x,s] cos grating with given frequency 
#	and orientation
#	N : size of vector
#	The cos wave's origin should be in the center of the vector

function sm = cosmat (N,freq,theta)

  sm = zeros(N,N);

  cx = round(N/2);
  cy = round(N/2);

  to_rad = pi / 180.0;
  rad = theta * to_rad;

  # get the relative coordinate matrix
  ymat = (((1:N)'*(zeros(1,N).+1)).-round(N/2))/N*2*pi;
  xmat = ymat';

  if (theta==0)

  	sm = cos(ymat*freq);

  else

	# get slope of the cose grating
  	a = tan(rad);

  	# distance
  	distmat =  flipud((xmat.-(ymat/a)).*sin(rad));

  	sm = cos(distmat*freq);

  endif

endfunction

