function [Cnew] = empcaol1(C)
%[Cnew] = empcaol1(C)
%
%does one complete E AND M step of empca by calling nextpoint(0)
%to get successive datapoints
%
% NB: nextpoint should return data with the mean already subtracted out

[p,k] = size(C);
CC = inv(C'*C)*C';
W = zeros(k,k);
Q = zeros(p,k);

[yi,status] = nextpoint(0);

while(status>0)
%  fprintf(1,'Now processing datapoint %d\r',status);
  xi = CC*yi;
  wi = xi*xi'; W = W+wi;
  qi = yi*xi'; Q = Q+qi;
  [yi,status] = nextpoint(0);
end

Cnew = Q*inv(W);




