//----------------------------------------------------------------------------
// 
//	file: ppmmua.cc
// 
//	function: plot mua in ppm format 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Thu Nov 12 17:11:57 CST 1998
// 
//	$Revision: 1.1 $ $Date: 1998/11/17 12:50:56 $
//	$Log: ppmmua.cc,v $
//	Revision 1.1  1998/11/17 12:50:56  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
#include <iostream.h>
#include <stdio.h>
#include <nnview/ppmio.h>
#include <nnview/matrix.h>
#include <nnview/filename.h>
#include <nnview/real.h>

//----------------------------------------------------------------------------
//	usage() 
//	  - prog usage
//----------------------------------------------------------------------------
void usage(int argc) {

  if (argc != 9) { 
    cout  << " usage: ppmmua <cols> <starting col #> "
   	  << "<width> <height> <start t> <end t> \n \t<scale> <outfilename>" 
	  << endl;
    cout  << "  input : stdin " << endl;
    cout  << "  input format : " 
	  << " 		string num num num  ... "  << endl
	  << "  * string is not used! " << endl;
    exit(0);
  }

}

//----------------------------------------------------------------------------
//	draw_bar() 
//	  - fill in given rectangle with a value
//----------------------------------------------------------------------------
void draw_bar(int col, int row, int width, int height,
	REAL value, REAL **dest) {
 

  int start = col*width;
  int start_row = row*height;

  for (int i=start; i<start+width; ++i) 
     for (int j=start_row; j<start_row+height; ++j)
		dest[i][j] = value;

}
  
//----------------------------------------------------------------------------
//	main() 
//	  - the main
//----------------------------------------------------------------------------
int main(int argc, char *argv[]) {

  // usage: ppmmua <cols> <starting col #> 
  //		<width> <height> <start t> <end t> <scale> < stdin

  usage(argc);
	
  int cols 	= atoi(argv[1]);
  int start_col = atoi(argv[2]);
  int width 	= atoi(argv[3]);
  int height 	= atoi(argv[4]);
  int start_t 	= atoi(argv[5]);
  int end_t 	= atoi(argv[6]);
  REAL scale   = atof(argv[7]);

  cout 
	<< "cols = " << cols 
	<< " start_col = " << start_col 
	<< " width = " << width 
	<< " height = " << height 
	<< " start_t = " << start_t 
	<< " end_t = " << end_t 
	<< " scale = " << scale  << endl;
  
  int ppm_width = width*(end_t-start_t+1);
  int ppm_height = height*cols;

  matrix<REAL> *ppm_buff= new matrix<REAL>(ppm_width,ppm_height);
  matrix<REAL> *data = new matrix<REAL>(end_t,cols);

  ppmio *io = new ppmio(ppm_buff->mat,ppm_width,ppm_height,256);

  // get data from stdin
  for (int t=0; t<end_t; ++t) {

    char buff[256];
    int junk;

     // skip columns
     cin >> buff;
     for (int k=2; k<start_col; ++k) cin >> junk;

     for (int k=0; k<cols; ++k)  {
	int d;
	cin >> data->mat[t][k];	
     }

  }

  // fill in the matrix
  for (int t=start_t; t<end_t; ++t)
     for (int k=0; k<cols; ++k) 
	draw_bar(t-start_t,k,width,height,data->mat[t][k],ppm_buff->mat);
	
  // write matrix to ppm file
  io->ppmwrite(argv[8]);

  delete io;
  delete ppm_buff;
  delete data;

}

