# function R = retina(n,m)
#	return a nxm matrix with values between [0:2] and 
#	a single cell (1:1) set to the value of 4.
#	0 : red, 1 : green, 2 : blue
#	display with hsvmap to get an approximate retinal mosaic
#	R,G : 0.5 arc min spacing
#	B : 10 arc min spacing
function R = retina(n,m)

  R = randn(n,m);
 
  # scale to [0:1]
  r = (R - min(min(R)))/(max(max(R))-min(min(R)));
  r = round(r*3);

  R = r;

  z = abs(round(sign(R-0.9999999999999)-1))/2;
  R = R + (z*3);
  R(1,1) = 4;
  # R = z;
endfunction  

